/* calltips.vala
 *
 * Copyright (C) 2008-2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

/**
 * The completion calltips
 */
public class Valide.Completion.Calltips : Gtk.Window
{
  private Gtk.Label label;

  private bool delete_event_cb (Gtk.Widget widget, Gdk.Event  event)
  {
    // Prevent the alt+F4 keys
    return true;
  }

  construct
  {
    Gdk.Color color;

    this.type = Gtk.WindowType.POPUP;
    this.type_hint = Gdk.WindowTypeHint.TOOLTIP;
    this.set_resizable (false);
    this.set_border_width (5);

    Gdk.Color.parse ("#fffbbb", out color);
    this.modify_bg (Gtk.StateType.NORMAL, color);

    this.label = new Gtk.Label ("");
    this.label.can_focus = false;
    this.label.show ();
    this.add (label);

    // Connect signals
    this.delete_event.connect (this.delete_event_cb);
  }

  /**
   * Show the calltips window
   *
   * @param source_buffer A Valide.SourceBuffer
   */
  public new void show (SourceBuffer source_buffer)
  {
    Symbols.Parser parser;
    Symbols.Symbol symbol;

    parser = new Symbols.Parser ();
    symbol = parser.get_current_symbol (source_buffer);
    if (symbol != null)
    {
      this.label.set_text (symbol.get_prototype ());
      base.show ();
    }
  }
}

