/* proposal.vala
 *
 * Copyright (C) 2008-2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

/**
 * A completion proposal
 */
public class Valide.Completion.Proposal : Object
{
  private Gdk.Pixbuf _icon;

  /**
   * The name
   */
  public string label
  {
    get;
    set construct;
  }

  /**
   * The icon
   */
  public Gdk.Pixbuf icon
  {
    get
    {
      return this._icon;
    }

    set construct
    {
      if (value == null)
      {
        this._icon = Utils.get_pixbuf_for_stock (Gtk.STOCK_FILE, Gtk.IconSize.SMALL_TOOLBAR);
      }
      else
      {
        this._icon = value;
      }
    }
  }

  /**
   * Create a new proposal
   *
   * @param label A name
   * @param icon A icon
   */
  public Proposal (string label, Gdk.Pixbuf? icon = null)
  {
    this.label = label;
    this.icon = icon;
  }
}

